﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
'Handler class
Sub Class_Globals
	
End Sub

Public Sub Initialize
	
End Sub

Sub Handle(req As ServletRequest, resp As ServletResponse)
	resp.Write(BuildHTML("sse", "message"))
End Sub

Sub BuildHTML(path As String, EventName As String) As String
	Return $"<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>

<h1>Server Sent Event(SSE) Example</h1>
- Receive PUSH message from server and show that message<br>
- You can do send PUSH message from form below.<br>
- You can receive message on another browser you will open.
<hr>
<h3>Message to PUSH</h3>
<input id="text_message" value="Test message">
<button id="send_message">Send PUSH Message</button>
(You can push enter to send)
<br>
<br>
<b>You can receive the message below even if you open <a href="http://localhost:51042/start" target="_blank">http://localhost:51042/start</a> in another browser or tab</b>
<hr>
<h3>Message received as PUSH from server</h3>
<div id="messages"></div>
<script>
    var eventSource = new EventSource('../${path}');
    var msgContent = document.querySelector('#messages');
    eventSource.addEventListener('message', function(event) {
        console.info('${path}: ' + event.data);
        msgContent.innerHTML += event.data + '<br>';
    });
    var msgText = document.querySelector('#text_message');
    var msgPostBtn = document.querySelector('#send_message');

    funcSendData = function(event) {
        sendData('${path}', {${EventName}: msgText.value});
        msgText.value='';
    };
    msgText.addEventListener('keypress', function (event) {
        if (event.key === 'Enter') {
            event.preventDefault();
            funcSendData(event);
        }
    });

    msgPostBtn.addEventListener('click', funcSendData);

    function sendData(url, data) {
        var XHR = new XMLHttpRequest();
        var urlEncodedData = '';
        var urlEncodedDataPairs = [];
        var name;

        for (name in data) {
            urlEncodedDataPairs.push(encodeURIComponent(name) + '=' + encodeURIComponent(data[name]));
        }

        urlEncodedData = urlEncodedDataPairs.join('&').replace(/%20/g, '+');

        XHR.addEventListener('load', function (event) {
        });
        XHR.addEventListener('error', function (event) {
        });

        XHR.open('POST', url);
        XHR.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        XHR.send(urlEncodedData);
    }
</script>
</body>
</html>"$
End Sub

